#region Copyright Morrison Shwartz, Inc - Author: Jonah Stagner 
/////////////////////////////////////////////////////////////////////////
// Copyright Morrison Schwartz, Inc 2003-2004, All rights reserved     //
//---------------------------------------------------------------------//
//Author: Jonah L. Stagner                                             //
//---------------------------------------------------------------------//
// This product is protected by US Copyright laws and international    //
// treaties.  For more information, see the End User License Agreement //
// in the application installation folder.                             //
//---------------------------------------------------------------------//
// Visit us on the web at: http://www.ms-inc.net                       //
/////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Drawing;
using System.Reflection;
using System.Collections;
using System.Windows.Forms;

using SharpTools;
using SharpTools.DOM;
using SharpTools.Settings;
using SharpTools.PluginInterface;

namespace ApiLookup
{

	public class ApiLookupPlugin : ISharpToolsPlugin
	{

		#region Private member variables 

		private const string TOOLWINDOWGUID = "{0D2936A5-BC2E-48cd-9ED3-75FCD6075032}";

		private SharpTools.Toolbar			toolbar;
		private SharpTools.ToolbarButton	cmdRun;
		private SharpTools.IDE.Toolwindow	toolWindow;

		#endregion 

		#region Constructor 

		public ApiLookupPlugin()
		{
			// @@@ Stub
		}

		#endregion 

		#region ISharpToolsPlugin Members 

		public string Description
		{
			get { return "Maps Win32 API functions to .NET equivalents, and assists in searching for more information about any API or .NET method found"; }
		}

		public string ID
		{
			get { return "SharpTools.Plugins.APILookup"; }
		}

		public string Name
		{
			get { return "API to .NET Mapping and Search"; }
		}

		public void OnConnect()
		{

			// Attach this plugin to the SharpTools toolbar
			toolbar = new SharpTools.Toolbar( "SharpTools" );

			// Add a button to the toolbar which, when clicked, will 
			// add the custom header to the code files
			cmdRun = (SharpTools.ToolbarButton) toolbar.Controls.Add( ControlType.Button, "Google" );
			cmdRun.Caption = "API Lookup";
			cmdRun.Tooltip = "Lookup API to .NET mapping";
			cmdRun.ButtonStyle = ButtonStyle.IconAndCaption;
			cmdRun.Picture = 460;
			cmdRun.Click += new EventHandler(cmdRun_Click);
		
		}

		public void OnDisconnect(SharpTools.PluginInterface.DisconnectMode disconnectMode)
		{
			// TODO:  Add ApiLookupPlugin.OnDisconnect implementation
		}

		#endregion

		private void cmdRun_Click(object sender, EventArgs e)
		{

			if( toolWindow == null )
			{
				
				ApiLookupUI ui = new ApiLookupUI();
				ui.Initialize();

				toolWindow = new SharpTools.IDE.Toolwindow( new Guid(TOOLWINDOWGUID), "Api Lookup", ui );
				toolWindow.Width = 250;
				toolWindow.Height = 550;

			}

			toolWindow.Activate();

		}

	}

}
