#region Copyright Morrison Shwartz, Inc - Author: Jonah Stagner 
/////////////////////////////////////////////////////////////////////////
// Copyright Morrison Schwartz, Inc 2003-2004, All rights reserved     //
//---------------------------------------------------------------------//
//Author: Jonah L. Stagner                                             //
//---------------------------------------------------------------------//
// This product is protected by US Copyright laws and international    //
// treaties.  For more information, see the End User License Agreement //
// in the application installation folder.                             //
//---------------------------------------------------------------------//
// Visit us on the web at: http://www.ms-inc.net                       //
/////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Collections;
using System.Windows.Forms;

using SharpTools;
using SharpTools.DOM;
using SharpTools.Settings;
using SharpTools.PluginInterface;

namespace CollectionBuilder
{

	/// <summary>
	/// Builds a strongly-typed collection from any class in the current project
	/// </summary>
	[Serializable]
	public class CollectionBuilderPlugin : ISharpToolsPlugin
	{

		#region Private data members 

		private SharpTools.Toolbar			toolbar;
		private SharpTools.ToolbarButton	cmdRun;

		#endregion 

		#region Constructor 

		public CollectionBuilderPlugin()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#endregion 

		#region ISharpToolsPlugin Members

		public string Description
		{
			get
			{
				string desc = "Builds a strongly-typed collection from any class in the current Project.";
				return desc;
			}
		}

		public string ID
		{
			get { return "200FB539-F7AC-48e7-A2B8-D3862832F1C0"; }
		}

		public string Name
		{
			get { return "CollectionBuilder"; }
		}

		public void OnConnect()
		{

			// Attach this plugin to the SharpTools toolbar
			toolbar = new SharpTools.Toolbar( "SharpTools" );

			// Add a button to the toolbar which, when clicked, will 
			// add the custom header to the code files
			cmdRun = (SharpTools.ToolbarButton) toolbar.Controls.Add( ControlType.Button, "Run" );
			cmdRun.Caption = "Generate Collection";
			cmdRun.Tooltip = "Create a strongly-typed collection";
			cmdRun.ButtonStyle = ButtonStyle.Icon;
			cmdRun.Picture = 312;
			cmdRun.Click += new EventHandler(cmdRun_Click);

		}

		public void OnDisconnect(SharpTools.PluginInterface.DisconnectMode disconnectMode)
		{
			// TODO:  Add CollectionBuilderPlugin.OnDisconnect implementation
		}

		#endregion

		private void cmdRun_Click(object sender, EventArgs e)
		{

			// Get a reference to the currently active project
			Project active = Globals.ActiveProject;
			if( active == null )
			{
				MessageBox.Show( "Please load a project before running this plugin", "SharpTools Collection Builder" );
				return;
			}

			CollectionProperties.ShowUI();

		}

	}

}
