#region Copyright Morrison Shwartz, Inc - Author: Jonah Stagner 
/////////////////////////////////////////////////////////////////////////
// Copyright Morrison Schwartz, Inc 2003-2004, All rights reserved     //
//---------------------------------------------------------------------//
//Author: Jonah L. Stagner                                             //
//---------------------------------------------------------------------//
// This product is protected by US Copyright laws and international    //
// treaties.  For more information, see the End User License Agreement //
// in the application installation folder.                             //
//---------------------------------------------------------------------//
// Visit us on the web at: http://www.ms-inc.net                       //
/////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace ScreenCapture
{
	/// <summary>
	/// Summary description for CaptureContainer.
	/// </summary>
	public class CaptureContainer : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CaptureContainer()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		public CaptureContainer( Image image, string Filename )
		{
			InitializeComponent();
			this.pictureBox1.Image = image;
			this.filename = Filename;
			this.isSaved = false;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.SystemColors.Control;
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// CaptureContainer
			// 
			this.AutoScroll = true;
			this.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.Controls.Add(this.pictureBox1);
			this.Name = "CaptureContainer";
			this.Size = new System.Drawing.Size(512, 392);
			this.ResumeLayout(false);

		}
		#endregion

		private string		filename;
		private bool		isSaved;

		public string Filename
		{
			get { return filename; }
			set { filename = value; }
		}

		public bool IsSaved
		{
			get { return isSaved; }
			set { isSaved = value; }
		}

		public void Save()
		{
			
			if( !IsSaved )
				SaveAs();

		}

		public void SaveAs()
		{

			try
			{

				SaveFileDialog sfd = new SaveFileDialog();
				sfd.Title = "Save Captured Image";
				sfd.Filter = "Compuserve GIF|*.gif|JPEG|*.jpg|Portable Network Graphics (PNG)|*.png|Windows Bitmap|*.bmp";
				sfd.CheckPathExists = true;
				sfd.DefaultExt = ".gif";
				sfd.DereferenceLinks = true;
				sfd.OverwritePrompt = true;
				sfd.ValidateNames = true;
				sfd.ShowDialog();

				if( sfd.FileName == "" )
					return;

				string extension = Path.GetExtension( sfd.FileName ).ToLower();
				System.Drawing.Imaging.ImageFormat format;
				switch( extension )
				{
					
					case ".gif":
						format = System.Drawing.Imaging.ImageFormat.Gif;
						break;
					
					case ".jpg":
						format = System.Drawing.Imaging.ImageFormat.Jpeg;
						break;
					
					case ".png":
						format = System.Drawing.Imaging.ImageFormat.Png;
						break;
					
					case ".bmp":
						format = System.Drawing.Imaging.ImageFormat.Bmp;
						break;
					
					default:
						throw new Exception( "Unrecognized file extension: " + extension );

				}
			
				this.pictureBox1.Image.Save( sfd.FileName, format );
				this.filename = sfd.FileName;

			}
			catch( Exception err )
			{
				MessageBox.Show( "Error saving file: " + err.Message, "Save Captured Image" );
			}

		}

	}

}
