#region Copyright Morrison Shwartz, Inc - Author: Jonah Stagner 
/////////////////////////////////////////////////////////////////////////
// Copyright Morrison Schwartz, Inc 2003-2004, All rights reserved     //
//---------------------------------------------------------------------//
//Author: Jonah L. Stagner                                             //
//---------------------------------------------------------------------//
// This product is protected by US Copyright laws and international    //
// treaties.  For more information, see the End User License Agreement //
// in the application installation folder.                             //
//---------------------------------------------------------------------//
// Visit us on the web at: http://www.ms-inc.net                       //
/////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace ScreenCapture
{
	/// <summary>
	/// Summary description for StartSelectCapture.
	/// </summary>
	public class StartSelectCapture : System.Windows.Forms.Form
	{

		#region 

		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public StartSelectCapture()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(StartSelectCapture));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(33, 33);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseUp);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(48, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(216, 128);
			this.label1.TabIndex = 1;
			this.label1.Text = @"To start the SelectObject capture, click on the image to the left.  When clicked, this form will disappear.  You will then, while still holding the mouse button down, drag the mouse over the window object you wish to capture.  Release the mouse button while over the desired window to finish the capture process.";
			// 
			// StartSelectCapture
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(272, 136);
			this.ControlBox = false;
			this.Controls.Add(this.label1);
			this.Controls.Add(this.pictureBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "StartSelectCapture";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Start SelectObject Capture";
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region Win32 API Imports 

		[StructLayout(LayoutKind.Sequential)]
		private struct RECT 
		{
			public int left;
			public int top;
			public int right;
			public int bottom;
		}

		[StructLayout(LayoutKind.Sequential)]
		private struct POINT
		{
			public int x;
			public int y;
		}

		[DllImport("user32.dll")]
		private static extern int WindowFromPoint( int xPoint, int yPoint );

		[DllImport("user32.dll")]
		private static extern int GetCursorPos( ref POINT lpPoint );

		[DllImport("user32.dll")]
		private static extern int GetWindowRect( IntPtr hwnd, ref RECT rc );

		[DllImport("user32.dll")]
		private static extern int GetClientRect( IntPtr hwnd, ref RECT rc );

		[DllImport("user32.dll")]
		private static extern int DrawFocusRect( IntPtr hdc, ref RECT rc );

		[DllImport("user32.dll")]
		private static extern int InflateRect( ref RECT rc, int x, int y );

		[DllImport("user32.dll")]
		private static extern int PtInRect( ref RECT rc, int ptx, int pty );

		[DllImport("user32.dll")]
		private static extern IntPtr GetWindowDC( IntPtr hwnd );

		[DllImport("user32.dll")]
		private static extern IntPtr GetDC( IntPtr hwnd );

		[DllImport("user32.dll")]
		private static extern IntPtr ReleaseDC( IntPtr hwnd, IntPtr hdc );

		#endregion 

		public delegate void WindowSelectedHandler( IntPtr hwnd );

		private bool					inSelectMode;
		private IntPtr					selectedWindow = IntPtr.Zero;
		private WindowSelectedHandler	selectHandler;

		public static void SelectWindow( WindowSelectedHandler SelectHandler )
		{

			if( SelectHandler == null )
				throw new ArgumentNullException( "SelectHandler" );

			StartSelectCapture dlg = new StartSelectCapture();
			dlg.TopMost = true;
			dlg.selectHandler = SelectHandler;
			dlg.Show();

		}

		private void Start()
		{
			this.TopMost = false;
			this.SendToBack();
			this.inSelectMode = true;
			this.pictureBox1.Capture = true;
			this.Location = new Point( Screen.PrimaryScreen.WorkingArea.Width * -1, Screen.PrimaryScreen.WorkingArea.Height * -1 );
		}

		private void HiliteWindow( IntPtr hwnd )
		{

			RECT windowRect = new RECT();
			int hResult = GetWindowRect( hwnd, ref windowRect );
			if( hResult <= 0 )
				return;

			IntPtr dc = IntPtr.Zero;
			try
			{

				dc = GetDC( IntPtr.Zero );
					
				for( int i = 0; i < 3; i++ )
				{
					DrawFocusRect( dc, ref windowRect );
					InflateRect( ref windowRect, -1, -1 );
				}

			}
			finally
			{
					
				if( dc != IntPtr.Zero )
					ReleaseDC( hwnd, dc );

			}

		}

		private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
		{
			Start();
		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{

			if( inSelectMode )
			{

				POINT cursorPos = new POINT();
				GetCursorPos( ref cursorPos );

				int handle = WindowFromPoint( cursorPos.x, cursorPos.y );
				if( handle <= 0 )
					return;

				IntPtr hwnd = new IntPtr( handle );
				if( hwnd == selectedWindow )
					return;

				HiliteWindow( selectedWindow );
				HiliteWindow( hwnd );
				selectedWindow = hwnd;

			}

		}

		private void pictureBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		
			if( inSelectMode )
			{
				
				if( selectedWindow != IntPtr.Zero )
					HiliteWindow( selectedWindow );

				inSelectMode = false;

				selectHandler( selectedWindow );

			}

			this.Close();

		}

	}

}
